## About the Book

[*Exploring Android*](https://commonsware.com/AndExplore/)
is an integrated set of tutorials, guiding you step-by-step in building an 
Android application. 

This book is updated a few times a year and is available through
[the Warescription](https://commonsware.com/warescription) program. Subscribers also have access to office
hours chats and other benefits.

This repository contains the source code for the sample apps profiled in the book. These 
samples are updated as the book is, with `git` tags applied to tie sample code versions to book
versions.

The book, and the samples, were written by Mark Murphy. You may also have run into him through
Stack Overflow:

<a href="http://stackoverflow.com/users/115145/commonsware">
<img src="http://stackoverflow.com/users/flair/115145.png" width="208" height="58" alt="profile for CommonsWare at Stack Overflow, Q&amp;A for professional and enthusiast programmers" title="profile for CommonsWare at Stack Overflow, Q&amp;A for professional and enthusiast programmers">
</a>

All of the source code in this archive is licensed under the
Apache 2.0 license except as noted.

Each directory in this repository reflects the "answers" to having completed
the tutorials to a certain point. So, for example, the `T11-Repository/`
directory contains a copy of the app being built, after having completed the
11th tutorial ("Setting Up a Repository"). If you wish to import
the results of one of the tutorials into Android Studio, you want to import
the `ToDo/` directory inside of one of the top-level directories. In other
words, import `T11-Repository/ToDo/`, not `T11-Repository/`.

Remember,
**always check the `gradle-wrapper.properties` file before importing anything into Android Studio**,
as there is always the chance that somebody has published material linking you to a hacked Gradle installation.

